"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.attachLifecycleEvents = void 0;
var _error = require("@webiny/error");
const attachLifecycleEvents = ({
  context
}) => {
  const blockActionOnEvent = async params => {
    const {
      model
    } = params;
    const isBeingDeleted = await context.cms.isModelBeingDeleted(model.modelId);
    if (!isBeingDeleted) {
      return;
    }
    throw new _error.WebinyError(`Model "${model.name}" is being deleted and you cannot create, update or delete any entries of this model.`);
  };
  /**
   * Entry actions.
   */
  context.cms.onEntryBeforeCreate.subscribe(blockActionOnEvent);
  context.cms.onEntryRevisionBeforeCreate.subscribe(blockActionOnEvent);
  context.cms.onEntryBeforeUpdate.subscribe(blockActionOnEvent);
  context.cms.onEntryBeforeUnpublish.subscribe(blockActionOnEvent);
  context.cms.onEntryBeforePublish.subscribe(blockActionOnEvent);
  context.cms.onEntryBeforeRepublish.subscribe(blockActionOnEvent);
  context.cms.onEntryBeforeRestoreFromBin.subscribe(blockActionOnEvent);
  context.cms.onEntryBeforeMove.subscribe(blockActionOnEvent);
  /**
   * Model actions.
   */
  context.cms.onModelBeforeUpdate.subscribe(blockActionOnEvent);
  context.cms.onModelBeforeCreateFrom.subscribe(blockActionOnEvent);
};
exports.attachLifecycleEvents = attachLifecycleEvents;

//# sourceMappingURL=attachLifecycleEvents.js.map